#include <amxmodx>
#include <amxmisc>
#include <hamsandwich>
#include <cstrike>
#include <fakemeta>
#include <fun>

#define is_valid_player(%1) (1 <= %1 <= 32)

new    
CTDefaultDano,
CTDefaultDano2,
TDefaultDano,
TDefaultDano2,
hTDefaultDano,
hTDefaultDano2,
hCTDefaultDano,
hCTDefaultDano2,
TCuchillo[33],
CTCuchillo[33];

new VIEW_MODELT[]    	= "models/JB/CT.mdl" 
new PLAYER_MODELT[] 	= "models/JB/CT2.mdl" 

new VIEW_MODELCT[]    	= "models/JB/T.mdl" 
new PLAYER_MODELCT[]   	= "models/JB/T2.mdl" 

new WORLD_MODEL[]    	= "models/w_knife.mdl"
new OLDWORLD_MODEL[]    	= "models/w_knife.mdl"

new const t_deploy[] 		= { "JB/T/TConvoca.wav", }
new const t_slash1[] 		= { "JB/T/Slash1.wav", }
new const t_slash2[] 		= { "JB/T/Slash2.wav", }
new const t_wall[] 		= { "JB/T/THitWall.wav" }
new const t_hit1[] 		= { "JB/T/THit1.wav",  }
new const t_hit2[] 		= { "JB/T/THit2.wav",  }
new const t_hit3[] 		= { "JB/T/THit3.wav",  }
new const t_hit4[] 		= { "JB/T/THit4.wav",  }
new const t_stab[] 		= { "JB/T/TStab.wav"  }

new const ct_deploy[] 		= { "JB/CT/CTConvoca.wav", }
new const ct_slash1[] 		= { "JB/CT/Slash1.wav", }
new const ct_slash2[] 		= { "JB/CT/Slash2.wav", }
new const ct_wall[] 		= { "JB/CT/CTHitWall.wav" }
new const ct_hit1[] 		= { "JB/CT/CTHit1.wav",  }
new const ct_hit2[] 		= { "JB/CT/CTHit2.wav",  }
new const ct_hit3[] 		= { "JB/CT/CTHit3.wav",  }
new const ct_hit4[] 		= { "JB/CT/CTHit4.wav",  }
new const ct_stab[] 		= { "JB/CT/CTStab.wav"  }

public plugin_init()
{
	register_plugin("[JB] Rankos", "1.5", "Giltinas")
	
	RegisterHam(Ham_Spawn,      "player", "Fwd_PlayerSpawn_Post",   1)
	RegisterHam(Ham_TakeDamage,     "player", "FwdTakeDamage",      0)
	
	register_event("CurWeapon",     "Event_Change_Weapon", "be", "1=1")
	
	register_forward(FM_SetModel,   "fw_SetModel")
	register_forward(FM_EmitSound,  "Fwd_EmitSound")

	TDefaultDano    = register_cvar("jb_dKnifeT",       "15") // T MOUSE1
	TDefaultDano2   = register_cvar("jb_dKnifeT2",      "25") // T MOUSE2
	CTDefaultDano   = register_cvar("jb_dKnifeCT",      "50") // CT MOUSE1
	CTDefaultDano2  = register_cvar("jb_dKnifeCT2",     "65") // CT MOUSE2

	hTDefaultDano   = register_cvar("jb_dHsKnifeT",     "20") // HS T MOUSE1
	hTDefaultDano2  = register_cvar("jb_dHsKnifeT2",    "30") // HS T MOUSE2
	hCTDefaultDano  = register_cvar("jb_dHsKnifeCT",    "65") // HS CT MOUSE1
	hCTDefaultDano2 = register_cvar("jb_dHsKnifeCT2",   "75") // HS CT MOUSE2
	
}

public plugin_precache()
{   
	precache_sound(t_deploy)
	precache_sound(t_slash1)
	precache_sound(t_slash2)
	precache_sound(t_stab)
	precache_sound(t_wall)
	precache_sound(t_hit1)
	precache_sound(t_hit2)
	precache_sound(t_hit3)
	precache_sound(t_hit4)
	
	precache_sound(ct_deploy)
	precache_sound(ct_slash1)
	precache_sound(ct_slash2)
	precache_sound(ct_stab)
	precache_sound(ct_wall)
	precache_sound(ct_hit1)
	precache_sound(ct_hit2)
	precache_sound(ct_hit3)
	precache_sound(ct_hit4)
	
	precache_model(VIEW_MODELT)    
	precache_model(PLAYER_MODELT)
	precache_model(VIEW_MODELCT)    
	precache_model(PLAYER_MODELCT)     
	precache_model(WORLD_MODEL)
	
	return PLUGIN_CONTINUE
}

public Fwd_PlayerSpawn_Post(id)
{
	if (is_user_alive(id))
	{
		if(get_user_team(id) == 1)
		{
			strip_user_weapons(id);
			give_item(id, "weapon_knife")  
		}
		
		set_user_footsteps(id, 0)
		CTCuchillo[id]  = 1
		TCuchillo[id]   = 1
	}
}

public FwdTakeDamage(victim, inflictor, attacker, Float:damage, damage_bits)
{
	if (is_valid_player(attacker) && get_user_weapon(attacker) == CSW_KNIFE)  
	{
		if(get_user_team(attacker) == 1)
		{
			if(TCuchillo[attacker])
			{      
				if(damage < 65.0)
				{
					SetHamParamFloat(4, get_pcvar_float(TDefaultDano))
					
					if(get_pdata_int(victim, 75) == HIT_HEAD)
					{
						SetHamParamFloat(4, get_pcvar_float(hTDefaultDano))
					}
				}
				else
				{              
					SetHamParamFloat(4, get_pcvar_float(TDefaultDano2))
					
					if(get_pdata_int(victim, 75) == HIT_HEAD)
					{
						SetHamParamFloat(4, get_pcvar_float(hTDefaultDano2))
					}
				}
			}
		}
		else if(get_user_team(attacker) == 2)
		{
			if(CTCuchillo[attacker])
			{    
				if(damage < 65.0)
				{
                                        SetHamParamFloat(4, get_pcvar_float(CTDefaultDano))
					
					if(get_pdata_int(victim, 75) == HIT_HEAD)
					{
						SetHamParamFloat(4, get_pcvar_float(hCTDefaultDano))
					}
				}
				else
				{
					SetHamParamFloat(4, get_pcvar_float(CTDefaultDano2))
					
					if(get_pdata_int(victim, 75) == HIT_HEAD)
					{
						SetHamParamFloat(4, get_pcvar_float(hCTDefaultDano2))
					}
				}
			}
		}
	}  
	return HAM_HANDLED;
}

public Event_Change_Weapon(id)
{
	
	new weaponID = read_data(2)
	
	switch (get_user_team(id))
	{
		case 1:
		{
			if(TCuchillo[id] && weaponID == CSW_KNIFE)
			{
				set_pev(id, pev_viewmodel2, VIEW_MODELT)
				set_pev(id, pev_weaponmodel2, PLAYER_MODELT)
			}   
		}
		case 2:
		{
			if(CTCuchillo[id] && weaponID == CSW_KNIFE)
			{
				set_pev(id, pev_viewmodel2, VIEW_MODELCT)
				set_pev(id, pev_weaponmodel2, PLAYER_MODELCT)
			}
		}
	}
	return PLUGIN_CONTINUE
}

public fw_SetModel(entity, model[])
{
	if(!pev_valid(entity))
		return FMRES_IGNORED
	
	if(!equali(model, OLDWORLD_MODEL))
		return FMRES_IGNORED
	
	new className[33]
	pev(entity, pev_classname, className, 32)
	
	if(equal(className, "weaponbox") || equal(className, "armoury_entity") || equal(className, "grenade"))
	{
		engfunc(EngFunc_SetModel, entity, WORLD_MODEL)
		return FMRES_SUPERCEDE
	}
	return FMRES_IGNORED
}

public Fwd_EmitSound(id, channel, const sample[], Float:volume, Float:attn, flags, pitch)
{
	
	if (!is_user_connected(id))
		return FMRES_IGNORED;
	
	if(CTCuchillo[id])
	{
		if(get_user_team(id) == 2)
		{
			if (equal(sample[8], "kni", 3))
			{
				if (equal(sample[14], "sla", 3))
				{
					switch (random_num(1, 2))
					{
						case 1: engfunc(EngFunc_EmitSound, id, channel, ct_slash1, volume, attn, flags, pitch)
							case 2: engfunc(EngFunc_EmitSound, id, channel, ct_slash2, volume, attn, flags, pitch)
						}
					
					return FMRES_SUPERCEDE;
				}
				if(equal(sample,"weapons/knife_deploy1.wav"))
				{
					engfunc(EngFunc_EmitSound, id, channel, ct_deploy, volume, attn, flags, pitch)
					return FMRES_SUPERCEDE;
				}
				if (equal(sample[14], "hit", 3))
				{
					if (sample[17] == 'w')
					{
						engfunc(EngFunc_EmitSound, id, channel, ct_wall, volume, attn, flags, pitch)
						return FMRES_SUPERCEDE;
					}
					else
					{
						switch (random_num(1, 4))
						{
							case 1: engfunc(EngFunc_EmitSound, id, channel, ct_hit1, volume, attn, flags, pitch)
								case 2: engfunc(EngFunc_EmitSound, id, channel, ct_hit2, volume, attn, flags, pitch)
								case 3: engfunc(EngFunc_EmitSound, id, channel, ct_hit3, volume, attn, flags, pitch)
								case 4: engfunc(EngFunc_EmitSound, id, channel, ct_hit4, volume, attn, flags, pitch)
							}
						
						return FMRES_SUPERCEDE;
					}
				}
				if (equal(sample[14], "sta", 3))
				{
					engfunc(EngFunc_EmitSound, id, channel, ct_stab, volume, attn, flags, pitch)
					return FMRES_SUPERCEDE;
				}
			}
		}   
	}
	
	if(TCuchillo[id])
	{
		if(get_user_team(id) == 1)
		{
			if (equal(sample[8], "kni", 3))
			{
				if (equal(sample[14], "sla", 3))
				{
					switch (random_num(1, 2))
					{
						case 1: engfunc(EngFunc_EmitSound, id, channel, t_slash1, volume, attn, flags, pitch)
							case 2: engfunc(EngFunc_EmitSound, id, channel, t_slash2, volume, attn, flags, pitch)
						}
					
					return FMRES_SUPERCEDE;
				}
				if(equal(sample,"weapons/knife_deploy1.wav"))
				{
					engfunc(EngFunc_EmitSound, id, channel, t_deploy, volume, attn, flags, pitch)
					return FMRES_SUPERCEDE;
				}
				if (equal(sample[14], "hit", 3))
				{
					if (sample[17] == 'w')
					{
						engfunc(EngFunc_EmitSound, id, channel, t_wall, volume, attn, flags, pitch)
						return FMRES_SUPERCEDE;
					}
					else
					{
						switch (random_num(1, 4))
						{
							case 1: engfunc(EngFunc_EmitSound, id, channel, t_hit1, volume, attn, flags, pitch)
								case 2: engfunc(EngFunc_EmitSound, id, channel, t_hit2, volume, attn, flags, pitch)
								case 3: engfunc(EngFunc_EmitSound, id, channel, t_hit3, volume, attn, flags, pitch)
								case 4: engfunc(EngFunc_EmitSound, id, channel, t_hit4, volume, attn, flags, pitch)
							}
						
						return FMRES_SUPERCEDE;
					}
				}
				if (equal(sample[14], "sta", 3))
				{
					engfunc(EngFunc_EmitSound, id, channel, t_stab, volume, attn, flags, pitch)
					return FMRES_SUPERCEDE;
				}
			}
		}   
	}   
	return FMRES_IGNORED;
}
